package cn.com.tenlion.materialstore.service.materialmap;

import ink.wgink.pojo.ListPage;
import ink.wgink.pojo.result.SuccessResultList;
import cn.com.tenlion.materialstore.pojo.dtos.materialmap.MaterialMapDTO;
import cn.com.tenlion.materialstore.pojo.vos.materialmap.MaterialMapVO;
import cn.com.tenlion.materialstore.pojo.bos.materialmap.MaterialMapBO;
import cn.com.tenlion.materialstore.pojo.pos.materialmap.MaterialMapPO;

import java.util.List;
import java.util.Map;

/**
 * @ClassName: IMaterialMapService
 * @Description: 经纬度素材
 * @Author: CodeFactory
 * @Date: 2021-05-28 11:01:59
 * @Version: 3.0
 **/
public interface IMaterialMapService {

    /**
     * 新增经纬度素材
     *
     * @param materialMapVO
     * @return
     */
    void save(MaterialMapVO materialMapVO);

    /**
     * 新增经纬度素材
     *
     * @param token
     * @param materialMapVO
     * @return
     */
    void save(String token, MaterialMapVO materialMapVO);

    /**
     * 新增经纬度素材
     *
     * @param materialMapVO
     * @return materialMapId
     */
    String saveReturnId(MaterialMapVO materialMapVO);

    /**
     * 新增经纬度素材
     *
     * @param token
     * @param materialMapVO
     * @return materialMapId
     */
    String saveReturnId(String token, MaterialMapVO materialMapVO);

    /**
     * 删除经纬度素材
     *
     * @param ids id列表
     * @return
     */
    void remove(List<String> ids);


    /**
     * 删除经纬度素材
     *
     * @param token
     * @param ids id列表
     * @return
     */
    void remove(String token, List<String> ids);

    /**
     * 删除经纬度素材（物理删除）
     *
     * @param ids id列表
     */
    void delete(List<String> ids);

    /**
     * 修改经纬度素材
     *
     * @param materialMapId
     * @param materialMapVO
     * @return
     */
    void update(String materialMapId, MaterialMapVO materialMapVO);

    /**
     * 修改经纬度素材
     *
     * @param token
     * @param materialMapId
     * @param materialMapVO
     * @return
     */
    void update(String token, String materialMapId, MaterialMapVO materialMapVO);

    /**
     * 经纬度素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialMapDTO get(Map<String, Object> params);

    /**
     * 经纬度素材详情
     *
     * @param materialMapId
     * @return
     */
    MaterialMapDTO get(String materialMapId);

    /**
     * 经纬度素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialMapBO getBO(Map<String, Object> params);

    /**
     * 经纬度素材详情
     *
     * @param materialMapId
     * @return
     */
    MaterialMapBO getBO(String materialMapId);

    /**
     * 经纬度素材详情
     *
     * @param params 参数Map
     * @return
     */
    MaterialMapPO getPO(Map<String, Object> params);

    /**
     * 经纬度素材详情
     *
     * @param materialMapId
     * @return
     */
    MaterialMapPO getPO(String materialMapId);

    /**
     * 经纬度素材列表
     *
     * @param params
     * @return
     */
    List<MaterialMapDTO> list(Map<String, Object> params);

    /**
     * 经纬度素材列表
     *
     * @param params
     * @return
     */
    List<MaterialMapBO> listBO(Map<String, Object> params);

    /**
     * 经纬度素材列表
     *
     * @param params
     * @return
     */
    List<MaterialMapPO> listPO(Map<String, Object> params);

    /**
     * 经纬度素材分页列表
     *
     * @param page
     * @return
     */
    SuccessResultList<List<MaterialMapDTO>> listPage(ListPage page);

    /**
     * 经纬度素材统计
     *
     * @param params
     * @return
     */
    Integer count(Map<String, Object> params);

    List<MaterialMapDTO> getByMaterialId(String materialId);

    void removeByMaterialId(String materialId);

    void updateCheck(String id);
}